#!/bin/sh
# This file was automatically generated
# by the pfSense service handler.

XGATE="/usr/local/gmnbin/xgate"
XGATEPID="/var/xgate/pid"
XGATEINI="/var/xgate/XGate.Ini"

PLATFORM=`cat /etc/platform`

if [ "$PLATFORM" = 'nanobsd' -a ! -e "/var/xgate" ]; then
     ln -s /mnt/data/xgate /var/xgate
fi

wait_state() {
    pop=`grep pop3port $XGATEINI | sed -e 's/pop3port=//'`
    smtp=`grep smtpport $XGATEINI | sed -e 's/smtpport//'` 
    inet=`ifconfig -a | grep -w inet | awk '{print $2}' | tr '\n' '|'`
    states="nostates"
    while [ ! -z "$states" ]; do 
	states=`pfctl -ss | egrep -e ":110|:25" | egrep -e "$inet"`
	sleep 2
    done
}

rc_start() {
	pid=`pgrep xgate`
	if [ ! -z "$pid" ]; then
	    echo "XGate is already running";
	    exit;
	fi

	# flush the state table to make sure there are no POP/SMTP clients binding ports
	wait_state
	$XGATE 1>/dev/null 2>&1 &
}

rc_stop() {
	pid=`pgrep xgate`
	if [ -z "$pid" ]; then	
	    return;
	fi

	$XGATE kill

	# Just to be sure...
	sleep 5
	if [ -f $XGATEPID ] ; then
  	    pkill -KILL xgate  2>/dev/null
	fi

	rm -f $XGATEPID
}

case $1 in
	start)
		rc_start
		;;
	stop)
		rc_stop
		;;
	restart)
		rc_stop
		rc_start
		;;
esac

