<?php
/* $Id$ */
/*
	sg_log.inc
	All rights reserved.

	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:

	1. Redistributions of source code must retain the above copyright notice,
	   this list of conditions and the following disclaimer.

	2. Redistributions in binary form must reproduce the above copyright
	   notice, this list of conditions and the following disclaimer in the
	   documentation and/or other materials provided with the distribution.

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
	AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
	AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	POSSIBILITY OF SUCH DAMAGE.
*/

$pgtitle = "RedPort email server: Log page";

require_once('globals.inc');
require_once('config.inc');
require_once("guiconfig.inc");
require_once('util.inc');
require_once('pfsense-utils.inc');
require_once('pkg-utils.inc');
require_once('service-utils.inc');

session_start();


if (file_exists("/usr/local/pkg/xgate.inc")) {
   require_once("/usr/local/pkg/xgate.inc");
}

if ( $_POST ) {
    $mode = $_SESSION['mode'];
    $clear = false;
    switch( $mode ) {
        case "connection": 
		$flog =  XGATE_VAR . '/connection.csv';
		$clear = true;
                break;
        case "pop3":   
		$flog = XGATE_VAR_LOG . '/pop3.log';		
                break;
        case "smtp":    
		$flog =  XGATE_VAR_LOG. '/smtp.log';
                break;
        default:
        case "usage":
	 	$clear = true;
		$flog = XGATE_VAR . '/usage.csv';
                break;
        case "transaction":
		$flog =  XGATE_VAR_LOG . '/xgate.log';
                break;
    }
    if ( isset($_POST['Download']) ) {
	if (file_exists($flog)) {
            $fs = filesize($flog);
	    $fn = basename($flog);
            header("Content-Type: application/octet-stream");
            header("Content-Disposition: attachment; filename=$fn");
            header("Content-Length: $fs");
            readfile("$flog");
	}	
    }
    if ( isset($_POST['Clear']) && isset($_POST['confirmClear']) ) {
	if ( $clear ) {
	    unlink($flog);
	    xgate_reinit();
	} else {
	    xgate_rotate_logs();
	}
    }
}

if ( !isset($mode) ) {
    $mode     = $_GET["mode"];
}
if (!in_array( $mode, array("transaction", "pop3", "smtp", "usage", "connection"))) $mode = "transaction";
$_SESSION['mode'] = $mode;
$selfpath = "/xgate/xgate_logs.php";

include("head.inc");

?>

<!-- HTML -->
<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
<?php include("fbegin.inc"); ?>
<p class="pgtitle"><?php echo "$pgtitle"; ?></p>
<form action="<?php echo $selfpath; ?>" method="post">
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<!-- Tabs -->
  <tr>
    <td>
<?php
        $tab_array = array();
        $tab_array[] = array(gettext("General"), 		false, "/pkg_edit.php?xml=xgate.xml&amp;id=0");
        $tab_array[] = array(gettext("Connection"),          	false, "/pkg_edit.php?xml=xgate_connection.xml&amp;id=0");
        $tab_array[] = array(gettext("Filters"),     		false, "/pkg_edit.php?xml=xgate_filters.xml&amp;id=0");
        $tab_array[] = array(gettext("Primary Accounts"),       false, "/pkg.php?xml=xgate_primary_accounts.xml");
        $tab_array[] = array(gettext("Sub Accounts"),         	false, "/pkg.php?xml=xgate_sub_accounts.xml");
        $tab_array[] = array(gettext("Spool"),              	false,  "/xgate/xgate_spool.php");
        $tab_array[] = array(gettext("Tools"),              	false,  "/xgate/xgate_tools.php");
        $tab_array[] = array(gettext("BigMail"),              	false,  "/xgate/xgate_bigmail.php");
        $tab_array[] = array(gettext("Logs"),              	true,  "$selfpath");
        display_top_tabs($tab_array);
?>
    </td>
  </tr>
  <tr>
    <td>
      <div id="mainarea">
        <table class="tabcont" width="100%" border="0" cellpadding="0" cellspacing="0">
          <tr>
            <td>

<?php
        # Subtabs
        $mode = $mode ? $mode : "blocked";
        $tab_array = array();
        $tab_array[] = array(gettext("Transaction log"),   ($mode == "transaction"), "{$selfpath}?mode=transaction");
        $tab_array[] = array(gettext("POP3 log"),          ($mode == "pop3"),        "{$selfpath}?mode=pop3");
        $tab_array[] = array(gettext("SMTP log"),          ($mode == "smtp"),        "{$selfpath}?mode=smtp");
        $tab_array[] = array(gettext("Usage CDRs"),        ($mode == "usage"),       "{$selfpath}?mode=usage");
        $tab_array[] = array(gettext("Connection Report"), ($mode == "connection"),  "{$selfpath}?mode=connection");
        $tab_array[] = array(gettext("Clear"),             ($mode == "clear"),       "{$selfpath}?mode=clear");
        $tab_array[] = array(gettext("Download"),          ($mode == "download"),    "{$selfpath}?mode=download");

        echo "<big>| ";
	$indx = 0;
        foreach ($tab_array as $ta) {
            $bl = $ta[1] ? "<b>"  : "";
            $br = $ta[1] ? "</b>" : "";
	    if ( $indx < 5 ) {
                echo "<a href=\"{$ta[2]}\">$bl{$ta[0]}$br</a> | ";
	    } else if ( $indx == 5 ) {
		echo "<input type=\"checkbox\" name=\"confirmClear\">";
	        echo "<input type=\"submit\" name=\"{$ta[0]}\" value=\"{$ta[0]}\"/>";
		echo " | ";
	    } else {
	        echo "<input type=\"submit\" name=\"{$ta[0]}\" value=\"{$ta[0]}\"/>";
		echo " | ";
	    }
	    $indx++;
        }
	
        echo "</big>";
?>
            </td>
          </tr>
          <tr>
            <td>
<?php
    $cont = "";
    switch( $mode ) {
        case "connection": 
		echo xgate_logrep( XGATE_VAR . '/connection.csv', 0, false );
                break;
        case "pop3":   
		echo xgate_logrep( XGATE_VAR_LOG . '/pop3.log', 50, false );
                break;
        case "smtp":    
		echo xgate_logrep( XGATE_VAR_LOG . '/smtp.log', 50, false );
                break;
        case "usage":
		echo xgate_logrep( XGATE_VAR . '/usage.csv', 0, false );
                break;
        case "transaction":
        default:        
		echo xgate_logrep( XGATE_VAR_LOG . '/xgate.log', 50, false );                        
                break;
    }
?>              
            </td>
          </tr>
        </table>
      </div>
    </td>
  </tr>
</table>
</form>

<?php include("fend.inc"); ?>

<script type="text/javascript"> 
  NiftyCheck(); 
  Rounded("div#mainarea","bl br","#FFF","#eeeeee","smooth");
</script>
</body>
</html>
